package be.iminds.ilabt.jfed.experimenter_gui.controller.view;

import be.iminds.ilabt.jfed.experimenter_gui.editor.ModelRspecEditor;
import be.iminds.ilabt.jfed.experimenter_gui.slice.NodePropertiesDialogFactory;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.lowlevel.GeniUserProvider;
import be.iminds.ilabt.jfed.preferences.JFedGuiPreferences;
import be.iminds.ilabt.jfed.util.ProxyPreferencesManager;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 1/29/2015
 * Time: 16:55
 */
@Singleton
public class ControllerUIFactory {
    private final NodePropertiesDialogFactory nodePropertiesDialogFactory;
    private final ImageUtil imageUtil;
    private final GeniUserProvider geniUserProvider;
    private final ProxyPreferencesManager proxyPreferencesManager;
    private final ControllerNodeFactory controllerNodeFactory;
    private final JFedGuiPreferences jFedPreferences;

    @Inject
    public ControllerUIFactory(ControllerNodeFactory controllerNodeFactory, NodePropertiesDialogFactory nodePropertiesDialogFactory, ImageUtil imageUtil, GeniUserProvider geniUserProvider, ProxyPreferencesManager proxyPreferencesManager, JFedGuiPreferences jFedPreferences) {
        this.controllerNodeFactory = controllerNodeFactory;
        this.nodePropertiesDialogFactory = nodePropertiesDialogFactory;
        this.imageUtil = imageUtil;
        this.geniUserProvider = geniUserProvider;
        this.proxyPreferencesManager = proxyPreferencesManager;
        this.jFedPreferences = jFedPreferences;
    }

    public ControllerUI createControllerUI(ModelRspecEditor modelRspecEditor) {
        return new ControllerUI(modelRspecEditor, nodePropertiesDialogFactory, imageUtil, geniUserProvider, proxyPreferencesManager, controllerNodeFactory, jFedPreferences);
    }
}
