package be.iminds.ilabt.jfed.experimenter_gui.debug;

import be.iminds.ilabt.jfed.experimenter_gui.Launch;
import com.cathive.fx.guice.GuiceFXMLLoader;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.io.IOException;
import java.net.URL;

/**
 * User: twalcari
 * Date: 12/2/2014
 * Time: 15:06
 */
@Singleton
public class DebugGuiFactory {
    private static final String DEBUG_GUI_FXML = "DebugGUI.fxml";

    private final GuiceFXMLLoader loader;

    @Inject
    public DebugGuiFactory(GuiceFXMLLoader loader) {
        this.loader = loader;
    }

    public void showDebugGui() {
        try {
            URL location = DebugGUI.class.getResource(DEBUG_GUI_FXML);
            GuiceFXMLLoader.Result result = loader.load(location);

            Stage debugStage = new Stage();
            debugStage.setTitle("jFed DEBUGGING");
            debugStage.setResizable(false);
            debugStage.setScene(new Scene(result.getRoot()));
            debugStage.getIcons().addAll(new Image(Launch.class.getResource("/images/jfed-logo_16.png").toExternalForm())
                    , new Image(Launch.class.getResource("/images/jfed-logo_32.png").toExternalForm())
                    , new Image(Launch.class.getResource("/images/jfed-logo_64.png").toExternalForm()));


            debugStage.show();
        } catch (IOException e) {
            throw new RuntimeException("Something went wrong while opening the debug screen", e);
        }
    }
}
