package be.iminds.ilabt.jfed.experimenter_gui.slice.actions;

import be.iminds.ilabt.jfed.experimenter_gui.slice.ExperimentController;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.ExperimentTasksFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.OpenConsoleTask;
import be.iminds.ilabt.jfed.experimenter_gui.ui.status.TaskStatusIndicator;
import be.iminds.ilabt.jfed.experimenter_gui.util.BrowserUtil;
import be.iminds.ilabt.jfed.highlevel.model.Sliver;
import javafx.stage.Window;

/**
 * User: twalcari
 * Date: 2/4/2015
 * Time: 11:37
 */
public class OpenConsoleAction extends ExperimentAction {
    private final Sliver sliver;
    private final BrowserUtil browserUtil;

    OpenConsoleAction(Window parentWindow, ExperimentController experimentController, Sliver sliver, ExperimentTasksFactory experimentTasksFactory, BrowserUtil browserUtil) {
        super(parentWindow, experimentController, experimentTasksFactory);
        this.sliver = sliver;
        this.browserUtil = browserUtil;
    }

    @Override
    public void run() {

        OpenConsoleTask openConsoleTask = experimentTasksFactory.createOpenConsoleTask(experiment, sliver);

        openConsoleTask.addTaskFinishedCallback(status ->{
            if(status == TaskStatusIndicator.Status.SUCCESS){
                browserUtil.openUrlInBrowser(openConsoleTask.getConsoleURL());
            }
        });

        experimentController.submitExperimentTask(openConsoleTask);


    }
}
