package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.HighLevelController;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.lowlevel.api.user_spec.UserSpec;

import java.util.List;

/**
 * User: twalcari
 * Date: 3/6/2015
 * Time: 10:11
 */
public class FetchSliceMemberSshKeysTask extends SingleCallExperimentTask {

    private final HighLevelController.SliceMembersSshKeysTask sliceMembersSshKeysTask;

    public FetchSliceMemberSshKeysTask(Experiment experiment, HighLevelController hlc) {
        super(experiment, hlc);

        updateTitle("Fetching SSH Keys from slice members");

        sliceMembersSshKeysTask = hlc.getSliceMemberSSHKeys(experiment.getSlice());
    }

    @Override
    public Task createTask() {
        return sliceMembersSshKeysTask;
    }

    public List<UserSpec> getKeys() {
        return sliceMembersSshKeysTask.getUserSpecs();
    }

    public boolean newExecutionNeeded(){
        return sliceMembersSshKeysTask.newExecutionNeeded();
    }
}
