package be.iminds.ilabt.jfed.highlevel.stitcher;

import org.slf4j.Logger;
import org.slf4j.Marker;

/**
 * StitchingHelpLogger
 */
public class StitchingReportWrappingLogger implements org.slf4j.Logger {
    private final org.slf4j.Logger wrappedLog;
    private StitchingReport.State state;

    public StitchingReportWrappingLogger(Logger wrappedLog) {
        this.wrappedLog = wrappedLog;
        this.state = null;
    }
    public StitchingReportWrappingLogger(Logger wrappedLog, StitchingReport.State state) {
        this.wrappedLog = wrappedLog;
        this.state = state;
    }

    public void setState(StitchingReport.State state) {
        this.state = state;
    }

    @Override
    public String getName() {
        return wrappedLog.getName();
    }

    @Override
    public boolean isTraceEnabled() {
        return wrappedLog.isTraceEnabled();
    }

    @Override
    public void trace(String s) {
        wrappedLog.trace(s);
    }

    @Override
    public void trace(String s, Object o) {
        wrappedLog.trace(s, o);
    }

    @Override
    public void trace(String s, Object o, Object o1) {
        wrappedLog.trace(s, o, o1);
    }

    @Override
    public void trace(String s, Object... objects) {
        wrappedLog.trace(s, objects);
    }

    @Override
    public void trace(String s, Throwable throwable) {
        wrappedLog.trace(s, throwable);
    }

    @Override
    public boolean isTraceEnabled(Marker marker) {
        return wrappedLog.isTraceEnabled(marker);
    }

    @Override
    public void trace(Marker marker, String s) {
        wrappedLog.trace(marker, s);
    }

    @Override
    public void trace(Marker marker, String s, Object o) {
        wrappedLog.trace(marker, s, o);
    }

    @Override
    public void trace(Marker marker, String s, Object o, Object o1) {
        wrappedLog.trace(marker, s, o, o1);
    }

    @Override
    public void trace(Marker marker, String s, Object... objects) {
        wrappedLog.trace(marker, s, objects);
    }

    @Override
    public void trace(Marker marker, String s, Throwable throwable) {
        wrappedLog.trace(marker, s, throwable);
    }

    @Override
    public boolean isDebugEnabled() {
        return wrappedLog.isDebugEnabled();
    }

    @Override
    public void debug(String s) {
        wrappedLog.debug(s);
        if (state != null) state.debug(s);
    }

    private static String makeMsg(String s, Object o) {
        return String.format(s, o);
    }
    private static String makeMsg(String s, Object o1, Object o2) {
        return String.format(s, o1, o2);
    }
    private static String makeMsg(String s, Object... o) {
        return String.format(s, o);
    }

    @Override
    public void debug(String s, Object o) {
        wrappedLog.debug(s, o);
        if (state != null) state.debug(makeMsg(s, o));
    }

    @Override
    public void debug(String s, Object o, Object o1) {
        wrappedLog.debug(s, o, o1);
        if (state != null) state.debug(makeMsg(s, o, o1));
    }

    @Override
    public void debug(String s, Object... objects) {
        wrappedLog.debug(s, objects);
        if (state != null) state.debug(makeMsg(s, objects));
    }

    @Override
    public void debug(String s, Throwable throwable) {
        wrappedLog.debug(s, throwable);
        if (state != null) state.debug(s, throwable);
    }

    @Override
    public boolean isDebugEnabled(Marker marker) {
        return wrappedLog.isDebugEnabled(marker);
    }

    @Override
    public void debug(Marker marker, String s) {
        wrappedLog.debug(marker, s);
        if (state != null) state.debug(s);
    }

    @Override
    public void debug(Marker marker, String s, Object o) {
        wrappedLog.debug(marker, s, o);
        if (state != null) state.debug(makeMsg(s, o));
    }

    @Override
    public void debug(Marker marker, String s, Object o, Object o1) {
        wrappedLog.debug(marker, s, o, o1);
        if (state != null) state.debug(makeMsg(s, o, o1));
    }

    @Override
    public void debug(Marker marker, String s, Object... objects) {
        wrappedLog.debug(marker, s, objects);
        if (state != null) state.debug(makeMsg(s, objects));
    }

    @Override
    public void debug(Marker marker, String s, Throwable throwable) {
        wrappedLog.debug(marker, s, throwable);
        if (state != null) state.debug(s, throwable);
    }

    @Override
    public boolean isInfoEnabled() {
        return wrappedLog.isInfoEnabled();
    }

    @Override
    public void info(String s) {
        wrappedLog.info(s);
        if (state != null) state.info(s);
    }

    @Override
    public void info(String s, Object o) {
        wrappedLog.info(s, o);
        if (state != null) state.info(makeMsg(s, o));
    }

    @Override
    public void info(String s, Object o, Object o1) {
        wrappedLog.info(s, o, o1);
        if (state != null) state.info(makeMsg(s, o, o1));
    }

    @Override
    public void info(String s, Object... objects) {
        wrappedLog.info(s, objects);
        if (state != null) state.info(makeMsg(s, objects));
    }

    @Override
    public void info(String s, Throwable throwable) {
        wrappedLog.info(s, throwable);
        if (state != null) state.info(s, throwable);
    }

    @Override
    public boolean isInfoEnabled(Marker marker) {
        return wrappedLog.isInfoEnabled(marker);
    }

    @Override
    public void info(Marker marker, String s) {
        wrappedLog.info(marker, s);
        if (state != null) state.info(s);
    }

    @Override
    public void info(Marker marker, String s, Object o) {
        wrappedLog.info(marker, s, o);
        if (state != null) state.info(makeMsg(s, o));
    }

    @Override
    public void info(Marker marker, String s, Object o, Object o1) {
        wrappedLog.info(marker, s, o, o1);
        if (state != null) state.info(makeMsg(s, o, o1));
    }

    @Override
    public void info(Marker marker, String s, Object... objects) {
        wrappedLog.info(marker, s, objects);
        if (state != null) state.info(makeMsg(s, objects));
    }

    @Override
    public void info(Marker marker, String s, Throwable throwable) {
        wrappedLog.info(marker, s, throwable);
        if (state != null) state.info(s, throwable);
    }

    @Override
    public boolean isWarnEnabled() {
        return wrappedLog.isWarnEnabled();
    }

    @Override
    public void warn(String s) {
        wrappedLog.warn(s);
        if (state != null) state.warn(s);
    }

    @Override
    public void warn(String s, Object o) {
        wrappedLog.warn(s, o);
        if (state != null) state.warn(makeMsg(s, o));
    }

    @Override
    public void warn(String s, Object... objects) {
        wrappedLog.warn(s, objects);
        if (state != null) state.warn(makeMsg(s, objects));
    }

    @Override
    public void warn(String s, Object o, Object o1) {
        wrappedLog.warn(s, o, o1);
        if (state != null) state.warn(makeMsg(s, o, o1));
    }

    @Override
    public void warn(String s, Throwable throwable) {
        wrappedLog.warn(s, throwable);
        if (state != null) state.warn(s, throwable);
    }

    @Override
    public boolean isWarnEnabled(Marker marker) {
        return wrappedLog.isWarnEnabled(marker);
    }

    @Override
    public void warn(Marker marker, String s) {
        wrappedLog.warn(marker, s);
        if (state != null) state.warn(s);
    }

    @Override
    public void warn(Marker marker, String s, Object o) {
        wrappedLog.warn(marker, s, o);
        if (state != null) state.warn(makeMsg(s, o));
    }

    @Override
    public void warn(Marker marker, String s, Object o, Object o1) {
        wrappedLog.warn(marker, s, o, o1);
        if (state != null) state.warn(makeMsg(s, o, o1));
    }

    @Override
    public void warn(Marker marker, String s, Object... objects) {
        wrappedLog.warn(marker, s, objects);
        if (state != null) state.warn(makeMsg(s, objects));
    }

    @Override
    public void warn(Marker marker, String s, Throwable throwable) {
        wrappedLog.warn(marker, s, throwable);
        if (state != null) state.warn(s, throwable);
    }

    @Override
    public boolean isErrorEnabled() {
        return wrappedLog.isErrorEnabled();
    }

    @Override
    public void error(String s) {
        wrappedLog.error(s);
        if (state != null) state.error(s);
    }

    @Override
    public void error(String s, Object o) {
        wrappedLog.error(s, o);
        if (state != null) state.error(makeMsg(s, o));
    }

    @Override
    public void error(String s, Object o, Object o1) {
        wrappedLog.error(s, o, o1);
        if (state != null) state.error(makeMsg(s, o, o1));
    }

    @Override
    public void error(String s, Object... objects) {
        wrappedLog.error(s, objects);
        if (state != null) state.error(makeMsg(s, objects));
    }

    @Override
    public void error(String s, Throwable throwable) {
        wrappedLog.error(s, throwable);
        if (state != null) state.error(s, throwable);
    }

    @Override
    public boolean isErrorEnabled(Marker marker) {
        return wrappedLog.isErrorEnabled(marker);
    }

    @Override
    public void error(Marker marker, String s) {
        wrappedLog.error(marker, s);
        if (state != null) state.error(s);
    }

    @Override
    public void error(Marker marker, String s, Object o) {
        wrappedLog.error(marker, s, o);
        if (state != null) state.error(makeMsg(s, o));
    }

    @Override
    public void error(Marker marker, String s, Object o, Object o1) {
        wrappedLog.error(marker, s, o, o1);
        if (state != null) state.error(makeMsg(s, o, o1));
    }

    @Override
    public void error(Marker marker, String s, Object... objects) {
        wrappedLog.error(marker, s, objects);
        if (state != null) state.error(makeMsg(s, objects));
    }

    @Override
    public void error(Marker marker, String s, Throwable throwable) {
        wrappedLog.error(marker, s, throwable);
        if (state != null) state.error(s, throwable);
    }
}
