package be.iminds.ilabt.jfed.lowlevel.connection;

import be.iminds.ilabt.jfed.lowlevel.JFedException;
import be.iminds.ilabt.jfed.util.JFedTrustStore;
import org.apache.xmlrpc.XmlRpcClient;

import java.util.Vector;

/**
 * SfaConnection: an XmlRpc connection (typically over https with or without user authentication or over http without any authentication)
 */
public abstract class SfaConnection extends JFedConnection {
    protected String lastCommand;
    protected Vector lastArgv;

    public SfaConnection(String serverUrl, JFedTrustStore jFedTrustStore, ProxyInfo proxyInfo, DebugInfo debugInfo) throws JFedException {
        super(serverUrl, jFedTrustStore, proxyInfo, debugInfo);
    }

    public abstract HttpInfoXmlRpcTransportFactory getXmlRpcTransportFactory();

    public abstract XmlRpcClient getXmlRpcClient();

    /**
     * remove date about last call stored in connection object
     */
    public abstract void clearLastCallData();

    /**
     * called by AbstractApi just before calling xmlRpcClient.execute(command, argv)
     *
     * This allows nice logging and processing of the executed command.
     *
     * This is used by MockSfaConnection to match the mock answer
     *
     * @param command
     * @param argv
     */
    public void logWillExecuteXmlRpc(String command, Vector argv) {
        this.lastCommand = command;
        this.lastArgv = argv;
    }
}
